<template>
    <div class="flex-1">
        <Button
            class="hidden lg:flex"
            icon="filePlus"
            v-bind:name="this.$t('open')"
            v-on:click="opening = true"
        />
        <Button
            class="lg:hidden"
            icon="filePlus"
            v-bind:name="this.$t('open')"
            v-on:click="$refs.fileR.click()"
        />
        <input
            v-on:change="upload($event.target.files)"
            accept=".txt, .rptz, .dynz"
            type="file"
            ref="fileR"
            class="hidden"
        />
        <OverlayBase v-bind:class="{ hidden: opening === false }" v-bind:title="this.$t('import')">
            <DragAndDrop class="mb-4" />
            <button v-on:click="opening = false" class="btn-red">
                {{ this.$t('cancel') }}
            </button>
        </OverlayBase>
    </div>
</template>

<script lang="ts">
    import { Component, Vue } from 'vue-property-decorator'
    import { State } from 'vuex-class'
    import DragAndDrop from '@/views/Home/components/Menu/components/InterfaceUnloaded/components/DragAndDrop.vue'
    import OverlayBase from '@/components/OverlayBase.vue'

    import { Factory } from '@/ts/factory'
    import { Project } from '@/ts/project'

    import Button from './Button.vue'

    @Component({
        components: {
            Button,
            DragAndDrop,
            OverlayBase,
        },
    })
    export default class C extends Vue {
        @State('project')
        private project!: Project

        @State('factory')
        private factory!: Factory

        private opening: boolean = false

        private async upload(files: File[]) {
            await this.factory.import(files, this.project)
        }

        private close() {
            this.opening = false
        }
    }
</script>
